"""
Nazwa: EKG-Link
Licencja: GPL

Autorzy:
DevNull (devnull2 at o2 dot pl)
mi_shell (mi_shell at o2 dot pl)


zalecane ustawienia w ekg:
alias -a >>ekg-link /^msg >>ekg-link %1
bind -a F6 >>ekg-link wo

"""

import ekg
import re, os, string

browser = "~/.gg/scripts/runbrowser 0"

#Link(i) gdzies w tresci wiadomosci, poprzedzony(e) http
msglink=re.compile(".*http:.*") 

#Wyodrebniony link, poprzedzony http
linka=re.compile("http:.*")    

#Link(i) gdzies w tresci wiadomosci, poprzedzony(e) www
wmsglink=re.compile(".*www.*") 

#Wyodrebniony link, poprzedzony www
wlinka=re.compile("www.*")    

app_name = ">>ekg-link"
ver = "0.1rc1w5"

url_list = []

#Zmienna wykorzysywana do obslugi polecen w skrypcie
wait_opt = 0 

def init():
    ekg.printf("generic", "EKG-Link \x1b[32m\x1b[1m[ON]")
    return 1


def deinit():
    ekg.printf("generic", "EKG-Link \x1b[31m\x1b[1m[OFF]")
    return 1


def handle_msg(uin, name, msgclass, text, time, secure):
    if (msglink.search(text)) or (wmsglink.search(text)):
        linki=string.split(text)
        for x in linki :
            if (linka.search(x)) or (wlinka.search(x)):
                if not x in url_list:
                    url_list.append(x)
                    ekg.printf("generic", "\x1b[1mEKG-Link:\x1b[0m Dodano nowy link: \x1b[34m%s" %x)
                else:
                    ekg.printf("generic", "\x1b[1mEKG-Link:\x1b[0m \x1b[33mOtrzymany link jest juz na liscie!\x1b[0m")
         
        return 1
    else:
        return 1



def handle_msg_own(rcpts, text):
    global wait_opt, app_name
    
    if rcpts == app_name:
        
      if text == "wo":
            wait_opt = 1
            ekg.printf("generic", "\x1b[1m>>EKG-Link\x1b[0m")
      else:
            exec_cmd(text)
            
      return 0

    if wait_opt == 1:
        exec_cmd(text)
        wait_opt = 0
        return 0      


def exec_cmd(text):

    if text == "l":
        show_url_list()
            
    elif (text == "df") or (text == "d"):
        del_first_url()
        
    elif text == "dl":
        del_last_url()
        
    elif text == "dd":
        del_all_urls()

    elif text[0] == "d" and text[1] != "d" and text[1] != "l" and text[1] != "f":
        num = text[1:]
        del_n_url(int(num))
        
    elif (text == "of") or (text == "o"):
        open_first_url()
        
    elif text == "ol":
        open_last_url()

    elif text == "oo":
        open_all_urls()

    elif text[0] == "o" and text[1] != "o" and text[1] != "l" and text[1] != "f":
        num = text[1:]
        open_n_url(int(num))
        
    elif text == "h":
        help()
        
    else:
        ekg.printf("generic", "\x1b[1mEKG-Link:\x1b[0m \x1b[31mBledna opcja! Nacisnij klawisz kontroli skryptu, a nastepnie wpisz\x1b[0m 'h' \x1b[31maby uzyskac pomoc.")


def show_url_list():
    global url_list
    
    
    if len(url_list) > 0:
        ekg.printf("generic", "\x1b[1m[l] EKG-Link:\x1b[0m Otrzymane linki:\n")
        for i in range(len(url_list)):
            ekg.printf("generic", "[%d] \x1b[34m%s \x1b[0m" % (i+1,url_list[i])) 

    else:
        ekg.printf("generic", "\x1b[1m[l] EKG-Link:\x1b[0m \x1b[33mBrak linkow na liscie!\x1b[0m")


def open_first_url():
    global browser, url_list

    if len(url_list) > 0:
        url = url_list[0]
        if url[0] == "w":
            
            ekg.printf("generic", "%s" % url)
            os.system(browser + ' http://%s 2> /dev/null' % url)
            ekg.command("window refresh")
        else:
            os.system(browser + ' %s 2> /dev/null' % url)
            ekg.command("window refresh")
    else:
        ekg.printf("generic", "\x1b[1m[of] EKG-Link:\x1b[0m \x1b[33mBrak linkow na liscie!\x1b[0m")



def open_last_url():        
    global browser, url_list

    if len(url_list) > 0:
        if url_list[len(url_list)-1][0] == "w":
            os.system(browser + ' http://%s 2> /dev/null' % url_list[len(url_list)-1])
            ekg.command("window refresh")
        else:
            os.system(browser + ' %s 2> /dev/null' % url_list[len(url_list)-1])
            ekg.command("window refresh")
    else:
        ekg.printf("generic", "\x1b[1m[ol] EKG-Link:\x1b[0m \x1b[33mBrak linkow na liscie!\x1b[0m")



def open_all_urls():
    global url_list, browser

    if len(url_list) == 0:
        ekg.printf("generic", "\x1b[1m[oo] EKG-Link:\x1b[0m \x1b[33mBrak linkow na liscie!\x1b[0m")
    else:
        for x in url_list:
            if x[0] == "w":
                os.system(browser + ' http://%s 2> /dev/null' % x)
            else:
                os.system(browser + ' %s 2> /dev/null' % x)

    ekg.command("window refresh")


def open_n_url(n):
    global url_list, browser

    if n-1 > url_list.index(url_list[-1]):
        ekg.printf("generic", "\x1b[1m[o%d] EKG-Link:\x1b[0m \x1b[33mLink o numerze\x1b[0m %d \x1b[33 nieistnieje!\x1b[0m" % n)
        
    else:
        if url_list[n-1][0] == "w":
            os.system(browser + ' http://%s 2> /dev/null' % url_list[n-1])
            ekg.command("window refresh")
        else:
            os.system(browser + ' %s 2> /dev/null' % url_list[n-1])
            ekg.command("window refresh")

def del_first_url():
    global url_list

    if len(url_list) == 0:
        ekg.printf("generic", "\x1b[1m[df] EKG-Link:\x1b[0m \x1b[31mBrak linkow do usuniecia!\x1b[0m")
    else:
        ekg.printf("generic", "\x1b[1m[df] EKG-Link:\x1b[0m \x1b[33mPierwszy link z listy (\x1b[0m\x1b[34m%s\x1b[0m\x1b[33m) zostal usuniety.\x1b[0m" % url_list[0])
        del url_list[0]


def del_last_url():
    global url_list

    if len(url_list) == 0:
        ekg.printf("generic", "\x1b[1m[dl] EKG-Link:\x1b[0m \x1b[33mBrak linkow do usuniecia!\x1b[0m")
    else:
        pop = url_list.pop()
        ekg.printf("generic", "\x1b[1m[dl] EKG-Link:\x1b[0m \x1b[33mOstatni link z listy (\x1b[0m\x1b[34m%s\x1b[0m\x1b[33m) zostal usuniety.\x1b[0m" % pop)

def del_n_url(n):
    global url_list

    if n-1 > url_list.index(url_list[-1]):
        ekg.printf("generic", "\x1b[1m[d%d] EKG-Link:\x1b[0m \x1b[33mLink o numerze\x1b[0m %d \x1b[33mnie istnieje!\x1b[0m" % n)
    else:
        ekg.printf("generic", "\x1b[1m[d%d] EKG-Link:\x1b[0m \x1b[33mLink (\x1b[0m\x1b[34m[%d]%s\x1b[0m\x1b[33m) zostal usuniety.\x1b[0m" % (n,url_list[n-1])) 
        url_list.pop(n-1)


def del_all_urls():
    global url_list

    ekg.printf("generic", "\x1b[1m[dd] EKG-Link:\x1b[0m \x1b[33mWszystkie linki zostaly usuniete z listy.\x1b[0m")
    url_list = []
        


def help():
    ekg.printf("generic", "\x1b[32m.-----------------------------------------------.\x1b[0m")
    ekg.printf("generic", "\x1b[32m|\x1b[0m Sterowanie EKG-Link - lista dostepnych opcji: \x1b[32m|\x1b[0m")
    ekg.printf("generic", "\x1b[32m`-----------------------------------------------'\x1b[0m")
    ekg.printf("generic", "")
    ekg.printf("generic", "\x1b[1m'df'\x1b[0m \x1b[31m-\x1b[0m usuwa pierwszy link z listy (lub 'd')")
    ekg.printf("generic", "\x1b[1m'dl'\x1b[0m\x1b[31m -\x1b[0m usuwa ostatni link z listy")
    ekg.printf("generic", "\x1b[1m'dd'\x1b[0m\x1b[31m -\x1b[0m usuwa wszystkie linki z listy")
    ekg.printf("generic", "\x1b[1m'dN'\x1b[0m\x1b[31m -\x1b[0m usuwa N-ty link z listy")
    ekg.printf("generic", "\x1b[1m'l'\x1b[0m \x1b[31m -\x1b[0m lista otrzymanych linkow")
    ekg.printf("generic", "\x1b[1m'of'\x1b[0m\x1b[31m -\x1b[0m otwiera pierwszy link z listy w przegladarce (lub 'o')")
    ekg.printf("generic", "\x1b[1m'ol'\x1b[0m\x1b[31m -\x1b[0m otwiera ostatni link z listy w przegladarce")
    ekg.printf("generic", "\x1b[1m'oo'\x1b[0m\x1b[31m -\x1b[0m otwiera wszystkie linki z listy w przegladarce")
    ekg.printf("generic", "\x1b[1m'oN'\x1b[0m\x1b[31m -\x1b[0m otwiera N-ty link z listy w przegladarce")

    ekg.printf("generic", "\x1b[1m'h'\x1b[0m \x1b[31m -\x1b[0m wyswietla pomoc")
    
